/*
 * Copyright (c) Openmind.  All rights reserved. http://www.openmindonline.it
 */
package it.openutils.spring.rmibernate.client.aspects;

import java.io.Serializable;
import java.lang.reflect.Method;

import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;


/**
 * @author fcarone
 * @version $Id: $
 */
public class ClientSerializationInterceptor implements MethodInterceptor, Serializable
{

    /**
     *
     */
    private static final long serialVersionUID = -2694751376173790718L;

    private HibernateLazyLoaderAspect hibernateLazyLoaderAspect;

    /**
     * @param hlla
     */
    public ClientSerializationInterceptor(HibernateLazyLoaderAspect hibernateLazyLoaderAspect)
    {
        this.hibernateLazyLoaderAspect = hibernateLazyLoaderAspect;
    }

    /**
     * {@inheritDoc}
     */
    public Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) throws Throwable
    {
        return hibernateLazyLoaderAspect.loadObject();
    }

}
